/***************************************************************************
                                  ksetaxes.cc
                             -------------------
    begin                : Sun Jun 25 2000
    copyright            : (C) 2000 by Kamil Dobkowski
    email                : kamildobk@friko.onet.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <octave/oct.h>
#include <iostream.h>
#include "octave-common.h"

DEFUN_DLD (ksetaxes, args, ,
" usage: prevAxesID = ksetaxes(newAxesID)\n"
"        currAxesID = ksetaxes()\n"
"\n"
"Sets the current plot window."
"Window number must be > 0."
"See also: ksetapp, kplot, kadd, kremove, kremoveall, kaddaxes, kremoveaxes, kimage, kcontour, kmesh, ksetmatrix" )
{
  int plot_num = axesNumber();

  if ( args.length() > 0 ) {
     int new_plot_num = (int )args(0).double_value();
     setAxes( new_plot_num );
     }

  return octave_value_list(1, octave_value((double )plot_num) );
}

